        PAGE    58,132                  ;Set page for HPLaserJet
;=====================================================================
; Title: CursHide
; Date: 9/21/1988
; Written by: Lloyd C. Bowen Jr.
; Written for: Binary file for DBase III+
; Purpose: Hide the cursor on screens that don't take input
;          and Change Cursor size for other reasons.         
;=====================================================================
; set title and instruction set
; NOTE that 8086 is the minimum (see the reference manual for 80286)
        TITLE   CursHide (BIN)   
        .8086
;=====================================================================
CODESG          SEGMENT PARA    'Code'
                ASSUME  CS:CODESG
                ORG     100H
CURSHIDE        PROC    FAR
BEGIN:  
                CMP     BYTE PTR [BX],48        ;0 means hide cursor
                JZ      HIDECURSOR              ;go hide the cursor
                CMP     BYTE PTR [BX],49        ;1 means restore cursor
                JZ      RESTCURSOR              ;go hide the cursor
                CMP     BYTE PTR [BX],50        ;2 means half cursor
                JZ      HALFCURSOR              ;go change the cursor
                CMP     BYTE PTR [BX],51        ;3 means long cursor
                JZ      LONGCURSOR              ;go change the cursor
                CMP     BYTE PTR [BX],52        ;4 means turn last cursor on
                JNE     ERREXIT                 ;parameter error

CURSON:
                MOV     AH,3                    ;read cursor position
                XOR     BH,BH                   ;for page 0
                INT     10H                     ;video interupt
                MOV     AH,1                    ;set cursor type function
                AND     CH,223                  ;bit 5 off turns cursor on
                INT     10H                     ;video interupt
                JMP     SHORT DONE
       
RESTCURSOR:
                MOV  AH,3                       ;func to get cursor lines
                MOV  BH,0                       ;page 0
                INT  10H                        ;CH=start, CL=stop
                CMP  CH,14                      ;14 lines?
                JNE  L3                         ;jump if 8 lines
                MOV  CH,11                      ;start=11
                MOV  CL,12                      ;stop=12
                JMP  SHORT L4                   ;jump ahead
L3:             MOV  CL,7                       ;stop=7
                MOV  CH,6                       ;start=6
L4:             MOV  AH,1                       ;func to set cursor lines
                INT  10H                        ;make cursor normal
                JMP     SHORT DONE

HIDECURSOR:
                MOV     AH,3                    ;read cursor position
                XOR     BH,BH                   ;for page 0
                INT     10H                     ;video interupt
                MOV     AH,1                    ;set cursor type function
                 OR     CH,32                   ;bit 5 on turns cursor off
                INT     10H                     ;video interupt
                JMP     SHORT DONE

HALFCURSOR:
                MOV  AH,3                       ;func to get cursor lines
                MOV  BH,0                       ;page 0
                INT  10H                        ;CH=start, CL=stop
                CMP  CL,12                      ;14 scan lines?
                JNE  L1                         ;jump if 8 lines
                MOV  CH,7                       ;start=7
                MOV  CL,13                      ;stop=13
                JMP  SHORT L2                   ;jump ahead
L1:             MOV  CL,7                       ;stop=7
                MOV  CH,1                       ;start=4
L2:             MOV  AH,1                       ;func to set cursor lines
                INT  10H                        ;make cursor long
                JMP     SHORT DONE
LONGCURSOR:
                MOV  AH,3                       ;func to get cursor lines
                MOV  BH,0                       ;page 0
                INT  10H                        ;CH=start, CL=stop
                CMP  CL,12                      ;14 scan lines?
                JNE  L5                         ;jump if 8 lines
                MOV  CL,13                      ;stop=13
                JMP  SHORT L6                   ;jump ahead
L5:             MOV  CL,7                       ;stop=7
L6:             MOV  CH,1                       ;start=1
                MOV  AH,1                       ;func to set cursor lines
                INT  10H                        ;make cursor long
                JMP     SHORT DONE

ERREXIT:
                PUSH    CS
                POP     DS                      ;ds = cs
                MOV     DX,OFFSET ERRMSG        ;pointer to message
                MOV     AH,9                    ;output characters to std out
                INT     21H                     ;dos interupt

DONE:
                RET                             ;return to dbase

ERRMSG          DB      0AH,0DH,'CURSHIDE: Bad Parameter',0DH,0AH,'$'

CURSHIDE        ENDP                            ;end of procedure
;
CODESG          ENDS                            ;end of segment
                END     BEGIN                   ;end of program

